commit afa9114c3c8105f11b88deea585a964118d4b752
Author: freddy77 <freddy77>
Date:   Mon Jul 7 13:17:51 2008 +0000

    make it works with ms odbvc

diff --git a/ChangeLog b/ChangeLog
index 030561a..0153ac1 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Jul 07 15:16:09 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/blob1.c: make it works with MS ODBC
+
 Mon Jul 07 13:23:52 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsodbc.h src/odbc/Makefile.am src/odbc/sql2tds.c:
 	- start wchar support
@@ -387,4 +390,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2542 2008/07/07 11:27:11 freddy77 Exp $
+$Id: ChangeLog,v 1.2543 2008/07/07 13:17:51 freddy77 Exp $
diff --git a/src/odbc/unittests/blob1.c b/src/odbc/unittests/blob1.c
index c03bf87..6536aaf 100755
--- a/src/odbc/unittests/blob1.c
+++ b/src/odbc/unittests/blob1.c
@@ -3,7 +3,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: blob1.c,v 1.5 2008/07/05 22:58:01 jklowden Exp $";
+static char software_version[] = "$Id: blob1.c,v 1.6 2008/07/07 13:17:51 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define CHECK_RCODE(t,h,m) \
@@ -76,7 +76,7 @@ check_hex(const char *buf, size_t len, unsigned int start, unsigned int step)
 	char symbol[3];
 
 	for (n = 0; n < len; ++n) {
-		sprintf(symbol, "%2x", (unsigned int)('a' + ((start+n) / 2 * step % ('z' - 'a' + 1))));
+		sprintf(symbol, "%2X", (unsigned int)('a' + ((start+n) / 2 * step % ('z' - 'a' + 1))));
 		if (buf[n] != symbol[(start+n) % 2])
 			return 0;
 	}
@@ -139,6 +139,7 @@ readBlobAsChar(SQLHSTMT * stmth, SQLUSMALLINT pos, int step)
 			break;
 		if (len > (SQLLEN) bufsize)
 			len = (SQLLEN) bufsize - 1;
+		len -= len % 2;
 		printf(">>     step %d: %d bytes readed\n", i, (int) len);
 		
 		check =	check_hex(buf, len, 2*987 + total, 25);
@@ -235,7 +236,7 @@ main(int argc, char **argv)
 					CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "SQLPutData StmtH");
 					printf(">> param %p: total bytes written = %d\n", (void *) p, NBYTES - (i&1));
 					
-					rcode = SQLPutData(m_hstmt, p + NBYTES - (i&1), NBYTES + (i&1));
+					rcode = SQLPutData(m_hstmt, p + NBYTES - 2 * (i&1), NBYTES + 2 * (i&1));
 
 					CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "SQLPutData StmtH");
 					printf(">> param %p: total bytes written = %d\n", (void *) p, NBYTES + (i&1));

